<?php
/*******************************************************************************
*	This file is part of Woogle4MediaWiki
*   (http://www.mediawiki.org/wiki/Extension:Woogle4MediaWiki)
*
*	Copyright (c) 2007 - 2009 Hans-Jörg Happel and
*	FZI Forschungszentrum Informatik and der Universität Karlsruhe (TH)
*
*   Woogle4MediaWiki is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   Woogle4MediaWiki is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with Woogle4MediaWiki.  If not, see <http://www.gnu.org/licenses/>.
*******************************************************************************/ 

/**
 * This class represents static variable for field values of 
 * knowledge artifacts - i.e. index elements
 */
class WoogleFd {
	public static $id 			= "id";
	public static $uri 			= "uri";
	public static $label 		= "label";
	public static $content 		= "content";
	public static $mimetype 	= "mimetype";
	public static $created 		= "created";
	public static $changed 		= "changed";
	public static $source 		= "source";
	public static $repository 	= "repository";
	public static $pages 		= "pages";
	public static $size 		= "size";
	public static $sizeChars 	= "sizeChars";
	public static $sizeLines 	= "sizeLines";
	public static $sizeWords 	= "sizeWords";
	public static $scope 		= "scope";
	public static $genre 		= "genre";
	public static $language 	= "language";
}

?>
