jQuery.woogle_socialresults = function(result, trashContainer, resultsContainer, 
										trashHeader, newResultForm) {
	
	// the act result
	var $me = result;
		
	// the main result-container
	var $resultsContainer = resultsContainer;
	
	// the trashHeader: show or hide depending if trash is empty
	var $trashHeader = trashHeader;
	
	// the trashContainer
	var $trashContainer = trashContainer;
	
	// Name of the new Result form, to find the insert-position
	var $newResultForm = newResultForm;
	
	// changes the cursor-style
	$('img', $me).css("cursor" , "pointer");
	$('img.result_comment').show();
	
	// checks the act situation of the result and decides
	// which options to show
	if($('input.isTrash', $me).val() ) {
		$('img.result_remove', $me).show(300);
		$('img.result_restore', $me).hide();
	} else {
		$('img.result_remove', $me).hide();
		$('img.result_restore', $me).show(300);
	}
	
	if($('input.rankedPos', $me).val() == 0) {
		$('img.result_promote', $me).show(300);
		$('img.result_degrade', $me).hide();
	} else {
		$('img.result_promote', $me).hide();
		$('img.result_degrade', $me).show(300);
	}
	$('textarea.comment', $me).bind('keyup', function() {
		var actval = $(this).val() ;
		var stdval = $('input.std_comment', $me).val() 
		if(actval != stdval) {
			$('input.add_comment', $me).removeAttr('disabled');			
		} else {
			$('input.add_comment', $me).attr('disabled', 'disabled');
		}
	});
	
	$('img.result_comment', $me).bind('click', function() {
		if( $('div.new_comment' ,$me).is(":visible") ) {
			$('div.new_comment' ,$me).slideUp(500);
			$('div.result_comments' ,$me).slideUp(500);
			$('div.no_comment').remove();
			jQuery.isCloning(false);
		} else {
			if( jQuery.isCloning() ) return true;
			$('div.new_comment' ,$me).slideDown(500);
			$('div.result_comments' ,$me).slideDown(500);
		}		
	});
	
	$('div.new_comment input.cancel', $me).bind('click', function() {		
		$('div.result_comments', $me).slideUp(500);
		$(this).parent('div').slideUp(500, function() {
			$('div.no_comment').remove();
			std_text = $('input.std_comment', $me).val(); 
			$('textarea.comment', $me).val( std_text );
			jQuery.isCloning(false);
		});
	});	
	
	$('div.new_comment input.add_comment', $me).bind('click', function() {
		$(this).parent('div').slideUp(500, function() {
			addComment();
			$('textarea.comment', $me).val( $('input.std_comment', $me).val() );
			$('div.no_comment').remove();
			// jQuery.isCloning(false);
			$(this).slideDown(500, function() {
				$('div.comment:last', $me).slideDown(500);
			});
		});
	});	
		
	// events called by click on the "result_promote" img
	$('img.result_promote', $me).bind('click', function() {		
		// deactivate all clicks during "Ajax"-request is being made
		if( jQuery.isCloning() ) return true;
		// first creates the clone
		$clone = $me.clone(true);
		// insert the clone
		$clone.insertAfter($newResultForm).hide().show(1000);		
		// hides the original
		$me.hide(1000, function() {
			// destroy the original ...
			$me.remove(); 
			// .. and let the clone be the original
			$me = $clone;
			// set Ranking pos to 1
			$('input.rankedPos',$me).val(1);
			// make the Ajax-Submit
			promoteResult();
			// change the buttons
			$('img.result_degrade', $me).show(300);
			$('img.result_promote', $me).hide(300);
			// Cloning completed
			jQuery.isCloning(false);
		});				
	});
	
	// events called by click on the "result_degrade" img
	$('img.result_degrade', $me).bind('click', function() {
		// deactivate all clicks during "Ajax"-request is being made
		if( jQuery.isCloning(true) ) return true;
		// first creates the clone
		$clone = $me.clone(true);
		// find the right position to insert the clone
		var origPos = $('input.originalPos', $me).val();
		var posToInsert = findPosToInsert( origPos );
		// insert the clone
		$clone.insertAfter(posToInsert).hide().show(1000);
		// hides the original
		$me.hide(1000, function() {
			// destroy the original ...
			$me.remove(); 
			// .. and let the clone be the original
			$me = $clone;
			// set Ranking pos to 0
			$('input.rankedPos', $me).val(0);
			// make the Ajax-Submit
			degradeResult();
			// change the buttons
			$('img.result_promote', $me).show(300);
			$('img.result_degrade', $me).hide(300);
			// cloning Completed
			jQuery.isCloning(false);
		});		
	});	
	
	// events called by click on the "result_promote" span
	$('img.result_restore', $me).bind('click', function(e) {
		// deactivate all clicks during "Ajax"-request is being made
		if( jQuery.isCloning(true) ) return true;
		// Hide the Button
		$('img.result_restore', $me).hide();		
		// first creates the clone
		$clone = $me.clone(true);				
		// find the right position to insert the clone
		var origPos = $('input.originalPos', $me).val();
		var posToInsert = findPosToInsert( origPos );
		
		// insert the clone
		$clone.insertAfter(posToInsert).hide().show(1000);
		
		// hides the original
		$me.hide(1000, function() {
			// destroy the original ...
			$me.remove(); 
			// .. and let the clone be the original
			$me = $clone;			
			// set Ranking pos to 1
			$('input.isTrash',$me).val(false);
			// make the Ajax-Submit
			restoreResult();			
			// change the buttons
			$('img.result_remove', $me).show(300);
			// show comment buttton
			$('img.result_comment', $me).show(300);
			// show ranking-image
			$('img.result_promote', $me).show(300);						
			// check, it the Trash should be hidded
			checkTheTrash();
			jQuery.isCloning(false);			
		});			
	});	
	
	// events called by click on the "result_remove" img
	$('img.result_remove', $me).bind('click', function(e) {
		// deactivate all clicks during "Ajax"-request is being made
		if( jQuery.isCloning() ) return true;			
		// first creates the clone
		$clone = $me.clone(true);
		// insert the clone
		$clone.prependTo($trashContainer).hide().show(1000);			
		// destroy the original ...
		// hides the original
		$me.slideUp(1000, function() {			
			$me.remove(); 
			// .. and let the clone be the original
			$me = $clone;			
			// set isTrash to true
			$('input.isTrash', $me).val( true );
			// set Ranking pos to 0
			$('input.rankedPos', $me).val('0');
			// make the Ajax-Submit
			removeResult();						
			// Hide ranking functions
			$('img.result_promote', $me).hide();
			$('img.result_degrade', $me).hide();
			$('img.result_remove', $me).hide();
			$('img.result_comment', $me).hide();
			
			// change the buttons
			$('img.result_restore', $me).show(300);			
			// show the trashHeader
			$trashHeader.fadeIn( 1000 );
			jQuery.isCloning(false);
		});			
	});
	/**
	 * 
	 * @param origPos		The origPos of the result wanted to be degraded
	 * @return the jQuery element to insert the result after
	 */
	function findPosToInsert( origPos ) {
		
		var posToInsert;
		// loop throw all result containing divs
		$('div.woogle_result', $resultsContainer).each(function(){
			// save the act result-div as jQuery-Obj.
			$resultItem = $(this);
			// is the act result ranked?
			var isRanked = $('input.rankedPos', $resultItem).val();
			// get the original pos of the actual result
			var pos = $('input.originalPos', $resultItem).val();
			// if the pos of item is smaller then the original one and its not ranked..
			if( pos < origPos && isRanked == 0) {
				// .. mark this as pos to insertAfter
				posToInsert = $resultItem;
			}
		});
		// check if an insertionposition is allready found
		if(posToInsert == undefined ) {
			// if not, loop again throw all results and find the last ranked
			$('div.woogle_result', $resultsContainer).each(function(){
				$resultItem = $(this);
				// is the act result ranked?
				var isRanked = $('input.rankedPos', $resultItem).val();
				// if result is ranked ..
				if( isRanked == 1) {
					// .. mark this as pos to insertAfter
					posToInsert = $resultItem;
				}
			});
		}	
		// if no pos is set, it gets added no newResult-pos
		if( posToInsert == undefined ) {
			posToInsert = $('div#newResult' , $resultsContainer );
		}
		// return the position
		return posToInsert;
	}
	
	/**
	 *
	 */
	function removeResult() {
		// get the actual searched query
		var query = $('input#searchedString').val();
		// get the link of the actual result
		var result_url = $('span.woogle_resultlink > a', $me).attr('href');				
		// call an ajax-request with the result-title
		sajax_do_call("woogleRemoveResult", [query, result_url], function(){ return true });
	}
	
	/**
	 *
	 */
	function restoreResult() {
		// get the actual searched query
		var query = $('input#searchedString').val();
		// get the link of the actual result
		var result_url = $('span.woogle_resultlink > a', $me).attr('href');		
		// call an ajax-request with the result-title
		sajax_do_call("woogleRestoreResult", [query, result_url], function(){ return true });
	}
	
	/**
	 *
	 */
	function promoteResult() {
		// get the actual searched query
		var query = $('input#searchedString').val();
		// get the link of the actual result
		var result_url = $('span.woogle_resultlink > a', $me).attr('href');		
		// call an ajax-request with the result-title
		sajax_do_call("wooglePromoteResult", [query, result_url], function(){ return true });
	}
	/**
	 * 
	 * 
	 */
	function addComment() {
		// get the actual searched query
		var query = $('input#searchedString').val();
		// get the link of the actual result
		var result_url = $('span.woogle_resultlink > a', $me).attr('href');		
		// call an ajax-request with the result-title
		var comment_text = $('textarea.comment', $me).val();
		sajax_do_call("woogleAddComment", [query, result_url, comment_text], function(request) {
			var data = request.responseText;
			if( data ) {				
				$('div.result_comments',$me).append(data);
			} else {
				return false;
			}
		});
	}
	/**
	 * 
	 * @return
	 */
	function degradeResult() {
		// get the actual searched query
		var query = $('input#searchedString').val();
		// get the link of the actual result
		var result_url = $('span.woogle_resultlink > a', $me).attr('href');		
		// call an ajax-request with the result-title
		sajax_do_call("woogleDegradeResult", [query, result_url], function(){ return true });
	}
	
	function checkTheTrash() {
		if( $('div.woogle_result' , $trashContainer).length == 0) {
			$trashHeader.fadeOut(1000);
			$trashContainer.hide();
		}
	}	
}

jQuery.woogle_addResult = function(button, trashContainer, resultsContainer, 
									trashHeader, newResultForm) {
	
	var $button = $('img',button);
	var $newResultForm = $(newResultForm);
	var $resultsContainer = $(resultsContainer);
	var query = $('input#searchedString').val();
	var $input = $('input.url' , $newResultForm);
	var $changeUrl = $('input.change_url', $newResultForm);
	
	$('table input[type="text"] , table textarea', $newResultForm).removeAttr("disabled");
	
	var options = {
		BE_func: 'woogleAjaxAutocompleteAddResult',
		redirect: false,		
		excludeStrings: {
			1: 'https://',
			2: 'http://',
			3: 'ftp://'
		},
		addResultForm: $newResultForm  
	};
	$input.autocomplete( options );
	
	// show the button for adding new results, but only if js is activated
	$(button).show();
	// change cursor-style
	$button.css("cursor" , "pointer");	
		
	$button.bind('click', function() {
		if( jQuery.isCloning() ) return true;
		// show the newResultForm
		$newResultForm.slideDown(1000);
		// save the width of the input width, because it gets later on changed
		newResultInputWidth = $input.width();		 
		$('input.cancel', newResultForm).bind('click', cancel);
		$('input.save', newResultForm).bind('click', save);		
	});
	
	function cancel() {		
		$newResultForm.slideUp(1000, function() {
			$('table input[type="text"] , textarea', $newResultForm).val('').removeAttr("disabled");
			$('table .error', $newResultForm).hide();
			$input.width(newResultInputWidth);
			$changeUrl.hide();
			jQuery.isCloning(false);
		});		
		jQuery.isCloning(false);
	}
	
	$changeUrl.bind('click', function(){
		$(this).animate({
			width: '0px',
			display: 'none'
		}, 500, function() { 
			$(this).hide(); 
			$input.animate({
				width: newResultInputWidth+'px'
			}, 500);
		});
		$('table input[type="text"] , textarea', $newResultForm).val('').val('').removeAttr("disabled");
	})
	
	function save() {
			
		$('table .error', $newResultForm).hide();
		var hasError = false;		
		var url = $('input.url', $newResultForm).val();
		var result_id = $('input.result_id', $newResultForm).val();
		var title = $('input.title', $newResultForm).val();
		var description = $('textarea.description', $newResultForm).val();		
				
		// Comment following lines if you dont want to validate them
		if( !validateUrl(url) ) hasError = true;
		// if( !validateTitle(title) ) hasError = true;		
		// if( !validateDescription(description) ) hasError = true;
			
		if( hasError) {
			return true;
		}
		
		$newResultForm.slideUp(1000, function() {			
			$('table input[type="text"], textarea', $newResultForm).val('');
			sajax_do_call("woogleAddResult", [query, url, result_id, title, description], showNewResult);
			$('table input[type="text"] , table textarea', $newResultForm).val('').removeAttr("disabled");
			$('table input[type="hidden"]', $newResultForm).val('false');
			$input.width(newResultInputWidth);
			$changeUrl.hide();
			jQuery.isCloning(false);
		});
	}
	
	/**
	 * receive data from server and put it into the result-box
	 * @param request 		the result deliviered from the ajax-request
	 * @return
	 */
	function showNewResult(request) {
		
		if(jQuery.isCloning()) return true;
		var data = request.responseText;
		
		if( data ) {
			$(data).insertAfter($newResultForm).hide().show(1000, function() {
				result = $(this);
				$('div.woogle_result').each(function() {
					$act = $(this);
					$origPos = $('.originalPos', $act);
					$origPos.val( parseInt($origPos.val()) + 1 );
					if( parseInt($origPos.val()) == 6 ) {
						$act.slideUp(1000, function(){
							$act.remove();
						});
					}
					
				});
				new jQuery.woogle_socialresults(result, trashContainer, resultsContainer, 
												trashHeader, newResultForm);
			});			
		}	
		jQuery.isCloning(false);
	}
	
	function validateTitle( title ) {
		if( title == '') {
			$('table .error_title', $newResultForm).show();
			return false;
		} else {			
			return true;
		}
	}
	function validateUrl( url ) {
		if( url == '') {
			$('table .error_url', $newResultForm).show();
			return false;
		} else {
			return true;
		}
	}
	function validateDescription( description ) {
		if( description == '') {
			$('table .error_description', $newResultForm).show();
			return false;
		} else {
			return true;
		}
	}
}

jQuery.extend({	
	/**
	 * @param v		True at the Begin of the cloning, false at the end, default: true
	 * @return true or false. Also changes the Value of actionFlas
	 */
	isCloning: function( v ) {
		v = typeof(v) != 'undefined' ? v : true;
				
		if( v ) {
			if( isCloning ) {
				return true;
			} else {
				isCloning = true ;
				return false;				
			}
		} else {			
			isCloning = false;
			return true;
		}		
	}
});


var isCloning = false;
var newResultInputWidth;

$(document).ready(function()
{
	var trashContainer = $('div#woogleResultsTrash');
	var trashHeader = $('div#woogleResultsTrashHeader');	
	var resultsContainer = $('div#woogleResults');	
	var newResultForm = $('div#newResult');
	
	$('div#addWoogleResult').each(function() {		
		var button = $(this);
		new jQuery.woogle_addResult(button, trashContainer, resultsContainer, 
									trashHeader, newResultForm);
	});
	
	// Show the Trash
	$('.trashShow' , trashHeader).bind('click', function() {
		trashContainer.slideDown(1000).fadeTo(0, 0.5);
	});
	
	// Hide the Trash
	$('.trashHide', trashHeader).bind('click', function() {
		trashContainer.slideUp(1000);
	});

	
	// loops throw all classes with the tag 'a' and creates js-objects
	$('div.woogle_result').each(function() {	
		var result = $(this);
		new jQuery.woogle_socialresults(result,	trashContainer, resultsContainer, 
										trashHeader, newResultForm);
	});

});