<?php
/*******************************************************************************
*	This file is part of Woogle4MediaWiki
*   (http://www.mediawiki.org/wiki/Extension:Woogle4MediaWiki)
*
*	Copyright (c) 2007 - 2009 Hans-Jörg Happel and
*	FZI Forschungszentrum Informatik and der Universität Karlsruhe (TH)
*
*   Woogle4MediaWiki is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   Woogle4MediaWiki is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with Woogle4MediaWiki.  If not, see <http://www.gnu.org/licenses/>.
*******************************************************************************/ 

/*define( 'MW_NO_SETUP', 1 );
require_once( '../../includes/WebStart.php' );
require_once( '../../includes/WebRequest.php' );
$wgRequest = new WebRequest();

$url = $wgRequest->getText('url');
$position = $wgRequest->getInt('position');*/

// Note:
// Do NOT use this code snippet again without paying attention to the explicit usage 
// of '?'. This could lead to problems (cf. http://octopus13.fzi.de:8080/browse/WOO-315)
/*$urlParts = explode("?", urldecode($_GET['url']), 2);
$url = $urlParts[0];
if (!empty($urlParts[1])) {
	$url .= '?' . urlencode($urlParts[1]);
}*/

require_once('blankstart.php');

WoogleUtil::profileIn('autocomplete.php');

$autocomplete = $_GET['q'];
WoogleUtil::debug('autocomplete.php - called for: ' . $autocomplete);

try {
	print('ich werde aufgerufen');
	$termFreqs = WoogleUtil::getQueryService()->getAutoComplete($autocomplete, 10);
} catch (Exception $e) {
	WoogleUtil::error("autocomplete.php" . $e->getMessage());
	exit;
}
//foreach ($termFreqs as $tf) {
//	echo '<li><div class="term">' . $tf['entity'] . '</div><div class="freq"><span class="informal">' . $tf['freq'] . '&nbsp;Ergebnisse</span></div></li>' . "\n";
//}

foreach( $termFreqs as $tf ) {
	echo $tf['entity'].'\n';
}

WoogleUtil::profileOut('autocomplete.php');
?>
